using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using ircam.jmax;

namespace ircam.jmax.dialogs
{
	/// <summary>
	/// Summary description for AboutDialog.
	/// </summary>
	public class AboutDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Label versionLabel;
		private System.Windows.Forms.Label osInfoLabel;
		private System.Windows.Forms.Label originalLabel;
		private System.Windows.Forms.Label netVersionLabel;
		private System.Windows.Forms.Label osVersionLabel;
		private System.Windows.Forms.Label appLabel;
		private System.Windows.Forms.PictureBox appPictureBox;
		private System.Windows.Forms.GroupBox sysInfoGroupBox;
		private System.Windows.Forms.Label netInfoLabel;
		private System.Windows.Forms.Label samplingRateLabel;
		private System.Windows.Forms.Label audioBufferLabel;
		private System.Windows.Forms.Label bufferInfoLabel;
		private System.Windows.Forms.Label rateInfoLabel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AboutDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.versionLabel.Text = JMaxVersion.Version;
			this.osInfoLabel.Text = Environment.OSVersion.ToString();
			this.netInfoLabel.Text = Environment.Version.ToString();
			this.rateInfoLabel.Text = (JMaxLibrary.DspControl.SamplingRate).ToString();
			this.bufferInfoLabel.Text = (JMaxLibrary.DspControl.FifoSize).ToString();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AboutDialog));
			this.okButton = new System.Windows.Forms.Button();
			this.sysInfoGroupBox = new System.Windows.Forms.GroupBox();
			this.bufferInfoLabel = new System.Windows.Forms.Label();
			this.rateInfoLabel = new System.Windows.Forms.Label();
			this.audioBufferLabel = new System.Windows.Forms.Label();
			this.samplingRateLabel = new System.Windows.Forms.Label();
			this.netInfoLabel = new System.Windows.Forms.Label();
			this.netVersionLabel = new System.Windows.Forms.Label();
			this.osInfoLabel = new System.Windows.Forms.Label();
			this.osVersionLabel = new System.Windows.Forms.Label();
			this.appLabel = new System.Windows.Forms.Label();
			this.versionLabel = new System.Windows.Forms.Label();
			this.appPictureBox = new System.Windows.Forms.PictureBox();
			this.originalLabel = new System.Windows.Forms.Label();
			this.sysInfoGroupBox.SuspendLayout();
			this.SuspendLayout();
			// 
			// okButton
			// 
			this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.okButton.Location = new System.Drawing.Point(288, 170);
			this.okButton.Name = "okButton";
			this.okButton.Size = new System.Drawing.Size(75, 24);
			this.okButton.TabIndex = 0;
			this.okButton.Text = "OK";
			// 
			// sysInfoGroupBox
			// 
			this.sysInfoGroupBox.Controls.Add(this.bufferInfoLabel);
			this.sysInfoGroupBox.Controls.Add(this.rateInfoLabel);
			this.sysInfoGroupBox.Controls.Add(this.audioBufferLabel);
			this.sysInfoGroupBox.Controls.Add(this.samplingRateLabel);
			this.sysInfoGroupBox.Controls.Add(this.netInfoLabel);
			this.sysInfoGroupBox.Controls.Add(this.netVersionLabel);
			this.sysInfoGroupBox.Controls.Add(this.osInfoLabel);
			this.sysInfoGroupBox.Controls.Add(this.osVersionLabel);
			this.sysInfoGroupBox.Location = new System.Drawing.Point(32, 72);
			this.sysInfoGroupBox.Name = "sysInfoGroupBox";
			this.sysInfoGroupBox.Size = new System.Drawing.Size(328, 90);
			this.sysInfoGroupBox.TabIndex = 4;
			this.sysInfoGroupBox.TabStop = false;
			this.sysInfoGroupBox.Text = "System Information";
			// 
			// bufferInfoLabel
			// 
			this.bufferInfoLabel.Location = new System.Drawing.Point(120, 68);
			this.bufferInfoLabel.Name = "bufferInfoLabel";
			this.bufferInfoLabel.Size = new System.Drawing.Size(192, 16);
			this.bufferInfoLabel.TabIndex = 11;
			// 
			// rateInfoLabel
			// 
			this.rateInfoLabel.Location = new System.Drawing.Point(120, 52);
			this.rateInfoLabel.Name = "rateInfoLabel";
			this.rateInfoLabel.Size = new System.Drawing.Size(192, 16);
			this.rateInfoLabel.TabIndex = 10;
			// 
			// audioBufferLabel
			// 
			this.audioBufferLabel.Location = new System.Drawing.Point(16, 68);
			this.audioBufferLabel.Name = "audioBufferLabel";
			this.audioBufferLabel.Size = new System.Drawing.Size(80, 16);
			this.audioBufferLabel.TabIndex = 9;
			this.audioBufferLabel.Text = "Audio Buffer";
			// 
			// samplingRateLabel
			// 
			this.samplingRateLabel.Location = new System.Drawing.Point(16, 52);
			this.samplingRateLabel.Name = "samplingRateLabel";
			this.samplingRateLabel.Size = new System.Drawing.Size(80, 16);
			this.samplingRateLabel.TabIndex = 8;
			this.samplingRateLabel.Text = "Sampling Rate";
			// 
			// netInfoLabel
			// 
			this.netInfoLabel.Location = new System.Drawing.Point(120, 32);
			this.netInfoLabel.Name = "netInfoLabel";
			this.netInfoLabel.Size = new System.Drawing.Size(192, 16);
			this.netInfoLabel.TabIndex = 7;
			// 
			// netVersionLabel
			// 
			this.netVersionLabel.Location = new System.Drawing.Point(16, 32);
			this.netVersionLabel.Name = "netVersionLabel";
			this.netVersionLabel.Size = new System.Drawing.Size(80, 16);
			this.netVersionLabel.TabIndex = 2;
			this.netVersionLabel.Text = ".NET Version";
			// 
			// osInfoLabel
			// 
			this.osInfoLabel.Location = new System.Drawing.Point(120, 16);
			this.osInfoLabel.Name = "osInfoLabel";
			this.osInfoLabel.Size = new System.Drawing.Size(192, 16);
			this.osInfoLabel.TabIndex = 1;
			// 
			// osVersionLabel
			// 
			this.osVersionLabel.Location = new System.Drawing.Point(16, 16);
			this.osVersionLabel.Name = "osVersionLabel";
			this.osVersionLabel.Size = new System.Drawing.Size(80, 16);
			this.osVersionLabel.TabIndex = 0;
			this.osVersionLabel.Text = "OS Version";
			// 
			// appLabel
			// 
			this.appLabel.Location = new System.Drawing.Point(96, 8);
			this.appLabel.Name = "appLabel";
			this.appLabel.Size = new System.Drawing.Size(28, 16);
			this.appLabel.TabIndex = 1;
			this.appLabel.Text = "jMax";
			// 
			// versionLabel
			// 
			this.versionLabel.Location = new System.Drawing.Point(132, 8);
			this.versionLabel.Name = "versionLabel";
			this.versionLabel.Size = new System.Drawing.Size(220, 16);
			this.versionLabel.TabIndex = 2;
			// 
			// appPictureBox
			// 
			this.appPictureBox.Image = ((System.Drawing.Image)(resources.GetObject("appPictureBox.Image")));
			this.appPictureBox.Location = new System.Drawing.Point(32, 16);
			this.appPictureBox.Name = "appPictureBox";
			this.appPictureBox.Size = new System.Drawing.Size(32, 32);
			this.appPictureBox.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.appPictureBox.TabIndex = 5;
			this.appPictureBox.TabStop = false;
			// 
			// originalLabel
			// 
			this.originalLabel.Location = new System.Drawing.Point(96, 32);
			this.originalLabel.Name = "originalLabel";
			this.originalLabel.Size = new System.Drawing.Size(256, 32);
			this.originalLabel.TabIndex = 3;
			this.originalLabel.Text = "Based on jMax, which was developed at IRCAM-Centre Georges Pompidou, Paris, Franc" +
				"e.";
			// 
			// AboutDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(394, 201);
			this.Controls.Add(this.originalLabel);
			this.Controls.Add(this.appPictureBox);
			this.Controls.Add(this.versionLabel);
			this.Controls.Add(this.appLabel);
			this.Controls.Add(this.sysInfoGroupBox);
			this.Controls.Add(this.okButton);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "AboutDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "About jMax";
			this.sysInfoGroupBox.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
	}
}
