//
// jMax
// Copyright (C) 1994, 1995, 1998, 1999 by IRCAM-Centre Georges Pompidou, Paris, France.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// See file LICENSE for further informations on licensing terms.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 

using System;
using System.Drawing;
using System.Windows.Forms;

using ircam.jmax.fts;
using ircam.jmax.editors.patcher.objects;

namespace ircam.jmax.editors.patcher
{
	//
	// The edit field contained in the editable objects (Message, Editable).
	//
	
	public class EditField
	{
		private Editable owner = null;
		private ErmesSketchPad sketch = null;

		// Private action classes 
		
//UNDONE: class EditField.StopEditAction
//		static internal class StopEditAction
//		{
//			internal StopEditAction() : base("stop")
//			{
//			}
//			
//			public void actionPerformed(EventArgs e)
//			{
//				EditField f = (EditField) getTextComponent(e);
//				
//				f.sketch.stopTextEditing();
//			}
//		}

		//
		// KeyListener that stops editing for a non multiline text object
		//		
		internal class EditFieldKeyListener
		{
			public EditFieldKeyListener(EditField editField)
			{
				this.editField = editField;
			}

			public void keyPressed(KeyEventArgs e)
			{
				if ((!editField.owner.isMultiline) && (e.KeyValue == (int) Keys.Enter))
				{
//UNDONE: Method 'java.awt.event.InputEvent.consume()' was not converted.
//					e.consume();
					editField.sketch.stopTextEditing();
				}
			}

			private EditField editField;
		}

		// The document listener that handle automatic resize
		
		internal class EditFieldListener
		{
//			public EditFieldListener(EditField editField)
//			{
//				this.editField = editField;
//			}
//
//			public void insertUpdate(EventArgs e)
//			{
//				editField.resizeIfNeeded();
//			}
//			
//			public void removeUpdate(EventArgs e)
//			{
//				editField.resizeIfNeeded();
//			}
//			
//			public void changedUpdate(EventArgs e)
//			{
//				editField.resizeIfNeeded();
//			}

			private EditField editField;
		}

		private EditFieldListener listener = new EditFieldListener();

		//--------------------------------------------------------
		// CONSTRUCTOR
		//--------------------------------------------------------

		private class CaretListener
		{
			public void caretUpdate(EventArgs e)
			{
//UNDONE: Method 'javax.swing.JTextArea.getText()' was not converted.
//				int lt = getText().Length;
//UNDONE: Method 'javax.swing.CaretEvent.getDot()' was not converted.
//				if (e.getDot() > lt)
//				{
//UNDONE: Method 'javax.swing.JTextArea.setSelectionEnd()' was not converted.
//					setSelectionEnd(lt);
//				}
			}
		}

		internal EditField(ErmesSketchPad editor)
		{
//			setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
//			Cursor = Cursors.IBeam;
//			
//			sketch = editor;
//			
//			setFont(FontCache.lookupFont(ircam.jmax.Platform.FONT_NAME, ircam.jmax.Platform.FONT_SIZE, ircam.jmax.Platform.FONT_STYLE));
//			
//			Keymap myMap = component.addKeymap(null, getKeymap());
//			
//			setKeymap(myMap);
//			
//			myMap.addActionForKeyStroke(KeyStroke.getKeyStroke((int) Keys.End, 0), new StopEditAction());
//			
//			KeyDown += new KeyEventHandler(new EditFieldKeyListener(this).keyPressed);
//			KeyUp += new KeyEventHandler(new EditFieldKeyListener(this).keyReleased);
//			KeyPress += new KeyPressEventHandler(new EditFieldKeyListener(this).keyTyped);
//			
//			setEditable(true);
//			setLineWrap(true);
//			setWrapStyleWord(true);
//			
//			Enter += new SystemEventHandler(this.focusGained);
//			Leave += new SystemEventHandler(this.focusLost);
//			
//			//bug fix: to avoid caret position bigger than text length after a drag selection
//			addCaretListener(new CaretListener(this));
		}

		// actually starts the edit operation.
		
		private Point location;
		private bool doneOnce = false;
		
		public void doEdit(Editable obj, Point p)
		{
			owner = obj;
			owner.Editing = true;
//UNDONE: Method 'javax.swing.JTextArea.getFont()' was not converted.
//			setFont(owner.getFont());
//			
//UNDONE: Method 'javax.swing.JTextArea.setText()' was not converted.
//			setText(owner.Args);
//
//UNDONE: Method 'javax.swing.JTextArea.setBackground()' was not converted.
//			setBackground(owner.TextBackground);
//			
//UNDONE: Method 'javax.swing.Component.setBounds()' was not converted.
//			setBounds = new Rectangle(owner.getX() + owner.TextXOffset, owner.getY() + owner.TextYOffset, owner.getWidth() - owner.VariableWidth - owner.TextWidthOffset, owner.getHeight() - owner.TextHeightOffset);
			
			if (!p.IsEmpty)
			{
				location = p;
//UNDONE: Method 'javax.swing.JComponent.getX()' was not converted.
//				location.X -= getX();
//				location.Y -= getY();
				
				// Workaround: viewToModel don't work if this is the
				// first time we make the JTextArea visible; it probabily
				// have something to do with the fact that the object is completed
				// by some calls in the event thread, and the information is not yet
				// available after the setVisible(true); so, the first time we
				// do the cursor placement using an invokeLater call ..
				
				if (doneOnce)
				{
//UNDONE: Method 'javax.swing.text.JTextComponent.viewToModel()' was not converted.
//					int pos = viewToModel(location);
//					
//					if ((pos >= 0) && (pos <= owner.Args.Length))
//					{
//UNDONE: Method 'javax.swing.text.JTextComponent.setCaretPosition()' was not converted.
//						setCaretPosition(pos);
//					}
//					else
//					{
//UNDONE: Method 'javax.swing.text.JTextComponent.setCaretPosition()' was not converted.
//						setCaretPosition(owner.Args.Length);
//					}
				}
				else
				{
//UNDONE: Method 'javax.swing.text.JTextComponent.viewToModel()' was not converted.
//					int pos = viewToModel(location);
//					if (pos >= 0)
//					{
//UNDONE: Method 'javax.swing.text.JTextComponent.setCaretPosition()' was not converted.
//						setCaretPosition(pos);
//					}
//					else
//					{
//UNDONE: Method 'javax.swing.text.JTextComponent.setCaretPosition()' was not converted.
//						setCaretPosition(owner.Args.Length);
//					}
	
					doneOnce = true;
				}
			}
			
//UNDONE: Method 'javax.swing.text.JTextComponent.getDocument()' was not converted.
//			getDocument().addDocumentListener(listener);
//UNDONE: Method 'javax.swing.JComponent.setVisible()' was not converted.
//			setVisible(true);
//UNDONE: Method 'javax.swing.JComponent.requestFocus()' was not converted.
//			requestFocus();
		}

		public void endEdit()
		{
//UNDONE: Method 'javax.swing.JTextArea.getText()' was not converted.
//			string aTextString = getText().Trim();
			
			owner.Editing = false;
		
//UNDONE: Method 'javax.swing.text.JTextComponent.getDocument()' was not converted.	
//			getDocument().removeDocumentListener(listener);
			
//UNDONE: Method 'javax.swing.JComponent.setVisible()' was not converted.
//			setVisible(false);
//			
//			if (!owner.Args.Equals(aTextString))
//			{
//				owner.redefine(aTextString);
//			}
//			else
//			{
//				owner.redraw();
//				owner.redrawConnections();
//			}
			
			owner = null;
		}

		public void abortEdit()
		{
			owner.Editing = false;
//UNDONE: Method 'javax.swing.text.JTextComponent.getDocument()' was not converted.	
//			getDocument().removeDocumentListener(listener);
//UNDONE: Method 'javax.swing.JComponent.setVisible()' was not converted.
//			setVisible(false);
			owner.Redraw();
			owner.redrawConnections();
		}

		/// <summary>Resize the box if needed; must be done in an invoke later,
		/// otherwise we get one character of error; don't ask me why
		/// </summary>
		
		internal void resizeIfNeeded()
		{
//UNDONE: Method 'javax.swing.JTextArea.getText()' was not converted.
//			if ((object) getText() != null)
//			{
//				Size d;
//					
//				owner.redraw();
//				owner.redrawConnections();
//			
//				if (owner.Multiline)
//				{
//UNDONE: Method 'javax.swing.JTextArea.getPreferredSize()' was not converted.
//					d = getPreferredSize();
//					owner.setHeight(d.Height + owner.TextHeightOffset);
//				}
//				else
//				{
//UNDONE: Method 'javax.swing.JTextArea.getText()' was not converted.
//					owner.WidthToText = getText();
//
//UNDONE: Method 'javax.swing.JTextArea.getSize()' was not converted.				
//					d = getSize();
//					d.Width = owner.Width - owner.VariableWidth - owner.TextWidthOffset;
//				}
//			
//				owner.redraw();
//				owner.redrawConnections();
//
//UNDONE: Method 'javax.swing.JTextArea.setSize()' was not converted.			
//				setSize(d);
//				sketch.fixSize();
//			}
		}
		
		// Support for cut editing operations
		
		internal void deleteSelectedText()
		{
//UNDONE: Method 'javax.swing.JTextArea.getText()' was not converted.
//			string s = getText();
//UNDONE: Method 'javax.swing.JTextArea.getSelectionStart()' was not converted.
//			setText(s.Substring(0, (getSelectionStart()) - (0)) + s.Substring(getSelectionEnd(), (s.Length) - (getSelectionEnd())));
		}

		public void focusGained(object sender, EventArgs e)
		{
			// Ignore
		}
		
		public void focusLost(object sender, EventArgs e)
		{
			if (owner != null)
				sketch.stopTextEditing();
		}

//UNDONE: Method 'javax.swing.text.JTextComponent.paintComponent()' was not converted.	
//		public void paintComponent(Graphics g)
//		{
//			base.paintComponent(g);
//		}
	}
}