using System;
using System.Drawing;
using System.Threading;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using ircam.jmax.fts;
using ircam.jmax.dialogs;
using ircam.jmax.editors.console;
using ircam.jmax.editors.project;
using ircam.jmax.editors.configuration;
using ircam.jmax.editors.patcher.objects;

namespace ircam.jmax.editors.patcher
{
	/// <summary>
	/// Summary description for ErmesSketchWindow.
	/// </summary>
	public class ErmesSketchWindow : System.Windows.Forms.Form, ircam.jmax.toolkit.IEditor
	{
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem14;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.MenuItem helpMenuItem;
		private System.Windows.Forms.MenuItem helpSeparatorMenuItem;
		private System.Windows.Forms.MenuItem aboutMenuItem;
		private System.Windows.Forms.MenuItem windowMenuItem;
		private System.Windows.Forms.MenuItem cascadeMenuItem;
		private System.Windows.Forms.MenuItem tileHorizonMenuItem;
		private System.Windows.Forms.MenuItem tileVerticalMenuItem;
		private System.Windows.Forms.MenuItem windowSeparatorMenuItem1;
		private System.Windows.Forms.MenuItem consoleMenuItem;
		private System.Windows.Forms.MenuItem viewMenuItem;
		private System.Windows.Forms.MenuItem fileMenuItem;
		private System.Windows.Forms.MenuItem openMenuItem;
		private System.Windows.Forms.MenuItem fileSeparatorMenuItem1;
		private System.Windows.Forms.MenuItem printMenuItem;
		private System.Windows.Forms.MenuItem printPreviewMenuItem;
		private System.Windows.Forms.MenuItem dspMenuItem;
		private System.Windows.Forms.MenuItem pageSetupMenuItem;
		private System.Windows.Forms.MenuItem closeMenuItem;
		private System.Windows.Forms.MenuItem saveMenuItem;
		private System.Windows.Forms.MenuItem saveAsMenuItem;
		private System.Windows.Forms.MenuItem contentsMenuItem;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private System.Windows.Forms.OpenFileDialog openProjectFileDialog;
		private System.Windows.Forms.OpenFileDialog openPackageFileDialog;
		private System.Windows.Forms.OpenFileDialog openConfigFileDialog;
		private System.Windows.Forms.MenuItem LockMenuItem;
		private System.Windows.Forms.MenuItem viewSeparatorMenuItem1;
		private System.Windows.Forms.MenuItem fontMenuItem;
		private System.Windows.Forms.MenuItem viewSeparatorMenuItem2;
		private System.Windows.Forms.MenuItem viewSeparatorMenuItem3;
		private System.Windows.Forms.MenuItem viewSeparatorMenuItem4;
		private System.Windows.Forms.MenuItem viewSeparatorMenuItem5;
		private System.Windows.Forms.MenuItem InspectMenuItem;
		private System.Windows.Forms.MenuItem rescaleMenuItem;
		private System.Windows.Forms.MenuItem frontMenuItem;
		private System.Windows.Forms.MenuItem backMenuItem;
		private System.Windows.Forms.MenuItem alignMenuItem;
		private System.Windows.Forms.MenuItem topMenuItem;
		private System.Windows.Forms.MenuItem leftMenuItem;
		private System.Windows.Forms.MenuItem bottomMenuItem;
		private System.Windows.Forms.MenuItem rightMenuItem;
		private System.Windows.Forms.MenuItem fileSeparatorMenuItem2;
		private System.Windows.Forms.MenuItem fileSeparatorMenuItem3;
		private System.Windows.Forms.MenuItem fileSeparatorMenuItem4;
		private System.Windows.Forms.MenuItem cutMenuItem;
		private System.Windows.Forms.MenuItem copyMenuItem;
		private System.Windows.Forms.MenuItem pasteMenuItem;
		private System.Windows.Forms.MenuItem duplicateMenuItem;
		private System.Windows.Forms.MenuItem editSeparatorMenuItem1;
		private System.Windows.Forms.MenuItem undoMenuItem;
		private System.Windows.Forms.MenuItem redoMenuItem;
		private System.Windows.Forms.MenuItem editSeparatorMenuItem2;
		private System.Windows.Forms.MenuItem selectAllMenuItem;
		private System.Windows.Forms.MenuItem editSeparatorMenuItem3;
		private System.Windows.Forms.MenuItem findMenuItem;
		private System.Drawing.Printing.PrintDocument printDocument;
		private System.Windows.Forms.PrintDialog printDialog;
		private System.Windows.Forms.PageSetupDialog pageSetupDialog;
		private System.Windows.Forms.PrintPreviewDialog printPreviewDialog;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ErmesSketchWindow()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public ErmesSketchWindow(FtsPatcherObject patcherObj)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			itsPatcher = patcherObj;

			// Make the title
			MakeTitle();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ErmesSketchWindow));
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.fileMenuItem = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.openMenuItem = new System.Windows.Forms.MenuItem();
			this.fileSeparatorMenuItem1 = new System.Windows.Forms.MenuItem();
			this.saveMenuItem = new System.Windows.Forms.MenuItem();
			this.saveAsMenuItem = new System.Windows.Forms.MenuItem();
			this.fileSeparatorMenuItem2 = new System.Windows.Forms.MenuItem();
			this.pageSetupMenuItem = new System.Windows.Forms.MenuItem();
			this.printMenuItem = new System.Windows.Forms.MenuItem();
			this.printPreviewMenuItem = new System.Windows.Forms.MenuItem();
			this.fileSeparatorMenuItem3 = new System.Windows.Forms.MenuItem();
			this.dspMenuItem = new System.Windows.Forms.MenuItem();
			this.fileSeparatorMenuItem4 = new System.Windows.Forms.MenuItem();
			this.closeMenuItem = new System.Windows.Forms.MenuItem();
			this.menuItem14 = new System.Windows.Forms.MenuItem();
			this.undoMenuItem = new System.Windows.Forms.MenuItem();
			this.redoMenuItem = new System.Windows.Forms.MenuItem();
			this.editSeparatorMenuItem1 = new System.Windows.Forms.MenuItem();
			this.cutMenuItem = new System.Windows.Forms.MenuItem();
			this.copyMenuItem = new System.Windows.Forms.MenuItem();
			this.pasteMenuItem = new System.Windows.Forms.MenuItem();
			this.duplicateMenuItem = new System.Windows.Forms.MenuItem();
			this.editSeparatorMenuItem2 = new System.Windows.Forms.MenuItem();
			this.selectAllMenuItem = new System.Windows.Forms.MenuItem();
			this.editSeparatorMenuItem3 = new System.Windows.Forms.MenuItem();
			this.findMenuItem = new System.Windows.Forms.MenuItem();
			this.viewMenuItem = new System.Windows.Forms.MenuItem();
			this.LockMenuItem = new System.Windows.Forms.MenuItem();
			this.viewSeparatorMenuItem1 = new System.Windows.Forms.MenuItem();
			this.InspectMenuItem = new System.Windows.Forms.MenuItem();
			this.viewSeparatorMenuItem2 = new System.Windows.Forms.MenuItem();
			this.rescaleMenuItem = new System.Windows.Forms.MenuItem();
			this.viewSeparatorMenuItem3 = new System.Windows.Forms.MenuItem();
			this.alignMenuItem = new System.Windows.Forms.MenuItem();
			this.topMenuItem = new System.Windows.Forms.MenuItem();
			this.leftMenuItem = new System.Windows.Forms.MenuItem();
			this.bottomMenuItem = new System.Windows.Forms.MenuItem();
			this.rightMenuItem = new System.Windows.Forms.MenuItem();
			this.viewSeparatorMenuItem4 = new System.Windows.Forms.MenuItem();
			this.frontMenuItem = new System.Windows.Forms.MenuItem();
			this.backMenuItem = new System.Windows.Forms.MenuItem();
			this.viewSeparatorMenuItem5 = new System.Windows.Forms.MenuItem();
			this.fontMenuItem = new System.Windows.Forms.MenuItem();
			this.windowMenuItem = new System.Windows.Forms.MenuItem();
			this.cascadeMenuItem = new System.Windows.Forms.MenuItem();
			this.tileHorizonMenuItem = new System.Windows.Forms.MenuItem();
			this.tileVerticalMenuItem = new System.Windows.Forms.MenuItem();
			this.windowSeparatorMenuItem1 = new System.Windows.Forms.MenuItem();
			this.consoleMenuItem = new System.Windows.Forms.MenuItem();
			this.helpMenuItem = new System.Windows.Forms.MenuItem();
			this.contentsMenuItem = new System.Windows.Forms.MenuItem();
			this.helpSeparatorMenuItem = new System.Windows.Forms.MenuItem();
			this.aboutMenuItem = new System.Windows.Forms.MenuItem();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.openProjectFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.openPackageFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.openConfigFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.printDocument = new System.Drawing.Printing.PrintDocument();
			this.printDialog = new System.Windows.Forms.PrintDialog();
			this.pageSetupDialog = new System.Windows.Forms.PageSetupDialog();
			this.printPreviewDialog = new System.Windows.Forms.PrintPreviewDialog();
			this.SuspendLayout();
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.fileMenuItem,
																					 this.menuItem14,
																					 this.viewMenuItem,
																					 this.windowMenuItem,
																					 this.helpMenuItem});
			// 
			// fileMenuItem
			// 
			this.fileMenuItem.Index = 0;
			this.fileMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItem2,
																						 this.openMenuItem,
																						 this.fileSeparatorMenuItem1,
																						 this.saveMenuItem,
																						 this.saveAsMenuItem,
																						 this.fileSeparatorMenuItem2,
																						 this.pageSetupMenuItem,
																						 this.printMenuItem,
																						 this.printPreviewMenuItem,
																						 this.fileSeparatorMenuItem3,
																						 this.dspMenuItem,
																						 this.fileSeparatorMenuItem4,
																						 this.closeMenuItem});
			this.fileMenuItem.Text = "&File";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "&New";
			// 
			// openMenuItem
			// 
			this.openMenuItem.Index = 1;
			this.openMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.openMenuItem.Text = "&Open...";
			this.openMenuItem.Click += new System.EventHandler(this.openMenuItem_Click);
			// 
			// fileSeparatorMenuItem1
			// 
			this.fileSeparatorMenuItem1.Index = 2;
			this.fileSeparatorMenuItem1.Text = "-";
			// 
			// saveMenuItem
			// 
			this.saveMenuItem.Index = 3;
			this.saveMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.saveMenuItem.Text = "&Save";
			// 
			// saveAsMenuItem
			// 
			this.saveAsMenuItem.Index = 4;
			this.saveAsMenuItem.Text = "Save &As...";
			// 
			// fileSeparatorMenuItem2
			// 
			this.fileSeparatorMenuItem2.Index = 5;
			this.fileSeparatorMenuItem2.Text = "-";
			// 
			// pageSetupMenuItem
			// 
			this.pageSetupMenuItem.Index = 6;
			this.pageSetupMenuItem.Text = "Page Set&up...";
			this.pageSetupMenuItem.Click += new System.EventHandler(this.pageSetupMenuItem_Click);
			// 
			// printMenuItem
			// 
			this.printMenuItem.Index = 7;
			this.printMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlP;
			this.printMenuItem.Text = "&Print...";
			this.printMenuItem.Click += new System.EventHandler(this.printMenuItem_Click);
			// 
			// printPreviewMenuItem
			// 
			this.printPreviewMenuItem.Index = 8;
			this.printPreviewMenuItem.Text = "Print Pre&view";
			this.printPreviewMenuItem.Click += new System.EventHandler(this.printPreviewMenuItem_Click);
			// 
			// fileSeparatorMenuItem3
			// 
			this.fileSeparatorMenuItem3.Index = 9;
			this.fileSeparatorMenuItem3.Text = "-";
			// 
			// dspMenuItem
			// 
			this.dspMenuItem.Checked = true;
			this.dspMenuItem.Index = 10;
			this.dspMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlDel;
			this.dspMenuItem.Text = "DSP";
			// 
			// fileSeparatorMenuItem4
			// 
			this.fileSeparatorMenuItem4.Index = 11;
			this.fileSeparatorMenuItem4.Text = "-";
			// 
			// closeMenuItem
			// 
			this.closeMenuItem.Index = 12;
			this.closeMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlW;
			this.closeMenuItem.Text = "&Close";
			this.closeMenuItem.Click += new System.EventHandler(this.closeMenuItem_Click);
			// 
			// menuItem14
			// 
			this.menuItem14.Index = 1;
			this.menuItem14.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.undoMenuItem,
																					   this.redoMenuItem,
																					   this.editSeparatorMenuItem1,
																					   this.cutMenuItem,
																					   this.copyMenuItem,
																					   this.pasteMenuItem,
																					   this.duplicateMenuItem,
																					   this.editSeparatorMenuItem2,
																					   this.selectAllMenuItem,
																					   this.editSeparatorMenuItem3,
																					   this.findMenuItem});
			this.menuItem14.Text = "&Edit";
			// 
			// undoMenuItem
			// 
			this.undoMenuItem.Index = 0;
			this.undoMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlZ;
			this.undoMenuItem.Text = "&Undo";
			// 
			// redoMenuItem
			// 
			this.redoMenuItem.Index = 1;
			this.redoMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlY;
			this.redoMenuItem.Text = "&Redo";
			// 
			// editSeparatorMenuItem1
			// 
			this.editSeparatorMenuItem1.Index = 2;
			this.editSeparatorMenuItem1.Text = "-";
			// 
			// cutMenuItem
			// 
			this.cutMenuItem.Index = 3;
			this.cutMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
			this.cutMenuItem.Text = "Cu&t";
			// 
			// copyMenuItem
			// 
			this.copyMenuItem.Index = 4;
			this.copyMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
			this.copyMenuItem.Text = "&Copy";
			// 
			// pasteMenuItem
			// 
			this.pasteMenuItem.Index = 5;
			this.pasteMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
			this.pasteMenuItem.Text = "&Paste";
			// 
			// duplicateMenuItem
			// 
			this.duplicateMenuItem.Index = 6;
			this.duplicateMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlD;
			this.duplicateMenuItem.Text = "&Duplicate";
			// 
			// editSeparatorMenuItem2
			// 
			this.editSeparatorMenuItem2.Index = 7;
			this.editSeparatorMenuItem2.Text = "-";
			// 
			// selectAllMenuItem
			// 
			this.selectAllMenuItem.Index = 8;
			this.selectAllMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlA;
			this.selectAllMenuItem.Text = "Se&lect All";
			// 
			// editSeparatorMenuItem3
			// 
			this.editSeparatorMenuItem3.Index = 9;
			this.editSeparatorMenuItem3.Text = "-";
			// 
			// findMenuItem
			// 
			this.findMenuItem.Index = 10;
			this.findMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlF;
			this.findMenuItem.Text = "&Find";
			this.findMenuItem.Click += new System.EventHandler(this.findMenuItem_Click);
			// 
			// viewMenuItem
			// 
			this.viewMenuItem.Index = 2;
			this.viewMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.LockMenuItem,
																						 this.viewSeparatorMenuItem1,
																						 this.InspectMenuItem,
																						 this.viewSeparatorMenuItem2,
																						 this.rescaleMenuItem,
																						 this.viewSeparatorMenuItem3,
																						 this.alignMenuItem,
																						 this.viewSeparatorMenuItem4,
																						 this.frontMenuItem,
																						 this.backMenuItem,
																						 this.viewSeparatorMenuItem5,
																						 this.fontMenuItem});
			this.viewMenuItem.Text = "&View";
			// 
			// LockMenuItem
			// 
			this.LockMenuItem.Checked = true;
			this.LockMenuItem.Index = 0;
			this.LockMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlE;
			this.LockMenuItem.Text = "Loc&k";
			// 
			// viewSeparatorMenuItem1
			// 
			this.viewSeparatorMenuItem1.Index = 1;
			this.viewSeparatorMenuItem1.Text = "-";
			// 
			// InspectMenuItem
			// 
			this.InspectMenuItem.Index = 2;
			this.InspectMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlI;
			this.InspectMenuItem.Text = "&Inspect";
			this.InspectMenuItem.Click += new System.EventHandler(this.InspectMenuItem_Click);
			// 
			// viewSeparatorMenuItem2
			// 
			this.viewSeparatorMenuItem2.Index = 3;
			this.viewSeparatorMenuItem2.Text = "-";
			// 
			// rescaleMenuItem
			// 
			this.rescaleMenuItem.Index = 4;
			this.rescaleMenuItem.Text = "Rescale Pa&tcher";
			this.rescaleMenuItem.Click += new System.EventHandler(this.rescaleMenuItem_Click);
			// 
			// viewSeparatorMenuItem3
			// 
			this.viewSeparatorMenuItem3.Index = 5;
			this.viewSeparatorMenuItem3.Text = "-";
			// 
			// alignMenuItem
			// 
			this.alignMenuItem.Index = 6;
			this.alignMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.topMenuItem,
																						  this.leftMenuItem,
																						  this.bottomMenuItem,
																						  this.rightMenuItem});
			this.alignMenuItem.Text = "&Align Objects";
			// 
			// topMenuItem
			// 
			this.topMenuItem.Index = 0;
			this.topMenuItem.Text = "Align &Top";
			// 
			// leftMenuItem
			// 
			this.leftMenuItem.Index = 1;
			this.leftMenuItem.Text = "Align &Left";
			// 
			// bottomMenuItem
			// 
			this.bottomMenuItem.Index = 2;
			this.bottomMenuItem.Text = "Align &Bottom";
			// 
			// rightMenuItem
			// 
			this.rightMenuItem.Index = 3;
			this.rightMenuItem.Text = "Align &Right";
			// 
			// viewSeparatorMenuItem4
			// 
			this.viewSeparatorMenuItem4.Index = 7;
			this.viewSeparatorMenuItem4.Text = "-";
			// 
			// frontMenuItem
			// 
			this.frontMenuItem.Index = 8;
			this.frontMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlU;
			this.frontMenuItem.Text = "&Bring To Front";
			// 
			// backMenuItem
			// 
			this.backMenuItem.Index = 9;
			this.backMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlB;
			this.backMenuItem.Text = "Se&nd To Back";
			// 
			// viewSeparatorMenuItem5
			// 
			this.viewSeparatorMenuItem5.Index = 10;
			this.viewSeparatorMenuItem5.Text = "-";
			// 
			// fontMenuItem
			// 
			this.fontMenuItem.Index = 11;
			this.fontMenuItem.Text = "&Font...";
			// 
			// windowMenuItem
			// 
			this.windowMenuItem.Index = 3;
			this.windowMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						   this.cascadeMenuItem,
																						   this.tileHorizonMenuItem,
																						   this.tileVerticalMenuItem,
																						   this.windowSeparatorMenuItem1,
																						   this.consoleMenuItem});
			this.windowMenuItem.Text = "&Window";
			// 
			// cascadeMenuItem
			// 
			this.cascadeMenuItem.Enabled = false;
			this.cascadeMenuItem.Index = 0;
			this.cascadeMenuItem.Text = "Casca&de";
			// 
			// tileHorizonMenuItem
			// 
			this.tileHorizonMenuItem.Enabled = false;
			this.tileHorizonMenuItem.Index = 1;
			this.tileHorizonMenuItem.Text = "Tile &Horizontally";
			// 
			// tileVerticalMenuItem
			// 
			this.tileVerticalMenuItem.Enabled = false;
			this.tileVerticalMenuItem.Index = 2;
			this.tileVerticalMenuItem.Text = "Tile &Vertically";
			// 
			// windowSeparatorMenuItem1
			// 
			this.windowSeparatorMenuItem1.Index = 3;
			this.windowSeparatorMenuItem1.Text = "-";
			// 
			// consoleMenuItem
			// 
			this.consoleMenuItem.Index = 4;
			this.consoleMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlM;
			this.consoleMenuItem.Text = "&Console";
			this.consoleMenuItem.Click += new System.EventHandler(this.consoleMenuItem_Click);
			// 
			// helpMenuItem
			// 
			this.helpMenuItem.Index = 4;
			this.helpMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.contentsMenuItem,
																						 this.helpSeparatorMenuItem,
																						 this.aboutMenuItem});
			this.helpMenuItem.Text = "&Help";
			// 
			// contentsMenuItem
			// 
			this.contentsMenuItem.Index = 0;
			this.contentsMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlF1;
			this.contentsMenuItem.Text = "&Contents...";
			this.contentsMenuItem.Click += new System.EventHandler(this.contentsMenuItem_Click);
			// 
			// helpSeparatorMenuItem
			// 
			this.helpSeparatorMenuItem.Index = 1;
			this.helpSeparatorMenuItem.Text = "-";
			// 
			// aboutMenuItem
			// 
			this.aboutMenuItem.Index = 2;
			this.aboutMenuItem.Text = "&About Max#...";
			this.aboutMenuItem.Click += new System.EventHandler(this.aboutMenuItem_Click);
			// 
			// pictureBox1
			// 
			this.pictureBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pictureBox1.BackColor = System.Drawing.SystemColors.Window;
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(624, 416);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 417);
			this.statusBar.Name = "statusBar";
			this.statusBar.Size = new System.Drawing.Size(624, 16);
			this.statusBar.TabIndex = 1;
			// 
			// printDialog
			// 
			this.printDialog.Document = this.printDocument;
			// 
			// pageSetupDialog
			// 
			this.pageSetupDialog.Document = this.printDocument;
			// 
			// printPreviewDialog
			// 
			this.printPreviewDialog.AutoScrollMargin = new System.Drawing.Size(0, 0);
			this.printPreviewDialog.AutoScrollMinSize = new System.Drawing.Size(0, 0);
			this.printPreviewDialog.ClientSize = new System.Drawing.Size(400, 300);
			this.printPreviewDialog.Document = this.printDocument;
			this.printPreviewDialog.Enabled = true;
			this.printPreviewDialog.Icon = ((System.Drawing.Icon)(resources.GetObject("printPreviewDialog.Icon")));
			this.printPreviewDialog.Location = new System.Drawing.Point(440, 54);
			this.printPreviewDialog.MinimumSize = new System.Drawing.Size(375, 250);
			this.printPreviewDialog.Name = "printPreviewDialog";
			this.printPreviewDialog.TransparencyKey = System.Drawing.Color.Empty;
			this.printPreviewDialog.Visible = false;
			// 
			// ErmesSketchWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(624, 433);
			this.Controls.Add(this.statusBar);
			this.Controls.Add(this.pictureBox1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu;
			this.Name = "ErmesSketchWindow";
			this.Text = "ErmesSketchWindow";
			this.ResumeLayout(false);

		}
		#endregion

		private void aboutMenuItem_Click(object sender, System.EventArgs e)
		{
			About();
		}

		private void consoleMenuItem_Click(object sender, System.EventArgs e)
		{
			consoleWindow.Activate();
		}

		private void contentsMenuItem_Click(object sender, System.EventArgs e)
		{
			Help.ShowHelp(this, helpfile);
		}

		private void InspectMenuItem_Click(object sender, System.EventArgs e)
		{
			ObjectInspector oi = new ObjectInspector();
			oi.ShowDialog(this);
			oi.Dispose();
		}

		private void rescaleMenuItem_Click(object sender, System.EventArgs e)
		{
			ScaleDialog sd = new ScaleDialog();
			sd.ShowDialog(this);
			sd.Dispose();		
		}

		private void findMenuItem_Click(object sender, System.EventArgs e)
		{
			Finder fd = new Finder();
			fd.ShowDialog(this);
			fd.Dispose();		
		}

		private void newPatcherMenuItem_Click(object sender, System.EventArgs e)
		{
			consoleWindow.NewPatcher();
		}

		private void openMenuItem_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog.ShowDialog() == DialogResult.OK)
			{
			}
		}

		private void pageSetupMenuItem_Click(object sender, System.EventArgs e)
		{
			try
			{
				DialogResult result = this.pageSetupDialog.ShowDialog();
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}		
		}

		private void printMenuItem_Click(object sender, System.EventArgs e)
		{
			try
			{
				DialogResult result = this.printDialog.ShowDialog();
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void printPreviewMenuItem_Click(object sender, System.EventArgs e)
		{
			try
			{
				DialogResult result = this.printPreviewDialog.ShowDialog();
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void closeMenuItem_Click(object sender, System.EventArgs e)
		{
			this.Dispose();
		}

		private void About()
		{		
			AboutDialog ad = new AboutDialog();
			ad.ShowDialog(this);
			ad.Dispose();						
		}

		public ircam.jmax.toolkit.IEditor IEditor
		{
			get
			{
				return itsSketchPad;
			}
		}

		public ErmesSketchPad SketchPad
		{
			get
			{
				return itsSketchPad;
			}			
		}

		private void MakeTitle()
		{
			SetTitle(MaxWindowManager.WindowManager.MakeUniqueWindowTitle(GetTitle()));
		}
		
		public void SetTitle(string fileName)
		{
			string title;
			
			int id = fileName.LastIndexOf('/');

			if (id != - 1)
				title = fileName.Substring(id + 1);
			else
				title = fileName;
			
			if (!Text.Equals(title))
			{
				base.Text = MaxWindowManager.WindowManager.MakeUniqueWindowTitle(title);
				MaxWindowManager.WindowManager.WindowChanged(this);
			}
		}

		internal string GetTitle()
		{
			string name;
				
			if (itsPatcher.IsARootPatcher)
			{
				name = itsPatcher.Name;
				if ((object) name == null)
					name = "untitled";
			}
			else if (itsPatcher is FtsTemplateObject)
				name = "template " + itsPatcher.Description;
			else if (itsPatcher is FtsPatcherObject)
				name = "patcher " + itsPatcher.Description;
			else
				name = "template " + itsPatcher.Description;
			return name;
		}

		private ircam.jmax.toolkit.IEditorContainer iEditorContainer;
		public ircam.jmax.toolkit.IEditorContainer IEditorContainer { get {return iEditorContainer;} }
		public void Close(bool doCancel) {}
		public void Print() {}
		public void Save() {}
		public void SaveAs() {}

		public void UpdateTitle() {}
		public FtsPatcherObject PatcherBounds
		{
			set
			{
//				int x;
//				int y;
//				int width;
//				int height;
//				
//				x = value.WindowX;
//				y = value.WindowY;
//				width = ScaleTransform.Instance.scaleX(value.WindowWidth);
//				height = ScaleTransform.Instance.scaleY(value.WindowHeight);
//				
//				if (width <= 0)
//					width = ScaleTransform.Instance.scaleX(480);
//				
//				if (height <= 0)
//					height = ScaleTransform.Instance.scaleY(500);
//				
//				Bounds = new System.Drawing.Rectangle(x, y, width + horizontalOffset(), height + verticalOffset());
			}
			
		}

		static public void InitModule()
		{
//			RepaintManager.setCurrentManager(new MaxRepaintManager());
//			ToolsPanel.registerToolsPanel();
		}

		private FtsPatcherObject itsPatcher;
		private ErmesSketchPad itsSketchPad;
		private const string helpfile = "MaxSharp.chm";
		private ConsoleWindow consoleWindow;
	}
}
