using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using ircam.jmax.fts;

namespace ircam.jmax.editors.project
{
	/// <summary>
	/// Summary description for NewProjectDialog.
	/// </summary>
	public class NewProjectDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button browseButton;
		private System.Windows.Forms.TextBox nameTextBox;
		private System.Windows.Forms.CheckBox copyCheckBox;
		private System.Windows.Forms.Label infoLabel;
		private System.Windows.Forms.Label fullNameLabel;
		private System.Windows.Forms.ComboBox pathComboBox;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button cancelButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public NewProjectDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.copyCheckBox.Checked = true;
			InitializeTextBox();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.nameTextBox = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.okButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.copyCheckBox = new System.Windows.Forms.CheckBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.pathComboBox = new System.Windows.Forms.ComboBox();
			this.fullNameLabel = new System.Windows.Forms.Label();
			this.infoLabel = new System.Windows.Forms.Label();
			this.browseButton = new System.Windows.Forms.Button();
			this.folderBrowserDialog = new System.Windows.Forms.FolderBrowserDialog();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// nameTextBox
			// 
			this.nameTextBox.Location = new System.Drawing.Point(80, 24);
			this.nameTextBox.Name = "nameTextBox";
			this.nameTextBox.Size = new System.Drawing.Size(400, 20);
			this.nameTextBox.TabIndex = 0;
			this.nameTextBox.Text = "";
			this.nameTextBox.TextChanged += new System.EventHandler(this.LabelTextChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(40, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "&Name:";
			// 
			// okButton
			// 
			this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.okButton.Location = new System.Drawing.Point(304, 200);
			this.okButton.Name = "okButton";
			this.okButton.Size = new System.Drawing.Size(104, 23);
			this.okButton.TabIndex = 2;
			this.okButton.Text = "OK";
			this.okButton.Click += new System.EventHandler(this.okButton_Click);
			// 
			// cancelButton
			// 
			this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cancelButton.Location = new System.Drawing.Point(416, 200);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.Size = new System.Drawing.Size(104, 23);
			this.cancelButton.TabIndex = 3;
			this.cancelButton.Text = "Cancel";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 23);
			this.label2.TabIndex = 4;
			this.label2.Text = "&Location:";
			// 
			// copyCheckBox
			// 
			this.copyCheckBox.Location = new System.Drawing.Point(16, 96);
			this.copyCheckBox.Name = "copyCheckBox";
			this.copyCheckBox.Size = new System.Drawing.Size(144, 24);
			this.copyCheckBox.TabIndex = 5;
			this.copyCheckBox.Text = "&Copy Current Project";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.pathComboBox);
			this.groupBox1.Controls.Add(this.fullNameLabel);
			this.groupBox1.Controls.Add(this.infoLabel);
			this.groupBox1.Controls.Add(this.browseButton);
			this.groupBox1.Controls.Add(this.copyCheckBox);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.nameTextBox);
			this.groupBox1.Location = new System.Drawing.Point(16, 16);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(500, 176);
			this.groupBox1.TabIndex = 6;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "New Project";
			// 
			// pathComboBox
			// 
			this.pathComboBox.Location = new System.Drawing.Point(80, 64);
			this.pathComboBox.Name = "pathComboBox";
			this.pathComboBox.Size = new System.Drawing.Size(320, 21);
			this.pathComboBox.TabIndex = 12;
			this.pathComboBox.TextChanged += new System.EventHandler(this.LabelTextChanged);
			// 
			// fullNameLabel
			// 
			this.fullNameLabel.Location = new System.Drawing.Point(144, 136);
			this.fullNameLabel.Name = "fullNameLabel";
			this.fullNameLabel.Size = new System.Drawing.Size(336, 16);
			this.fullNameLabel.TabIndex = 11;
			// 
			// infoLabel
			// 
			this.infoLabel.Location = new System.Drawing.Point(16, 136);
			this.infoLabel.Name = "infoLabel";
			this.infoLabel.Size = new System.Drawing.Size(128, 16);
			this.infoLabel.TabIndex = 10;
			this.infoLabel.Text = "Project will be created at";
			// 
			// browseButton
			// 
			this.browseButton.Location = new System.Drawing.Point(408, 64);
			this.browseButton.Name = "browseButton";
			this.browseButton.TabIndex = 8;
			this.browseButton.Text = "&Browse...";
			this.browseButton.Click += new System.EventHandler(this.browseButton_Click);
			// 
			// NewProjectDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(526, 239);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.cancelButton);
			this.Controls.Add(this.okButton);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "NewProjectDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "New Project";
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		private void InitializeTextBox()
		{
			string path = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
			pathComboBox.Text = path;
			pathComboBox.Items.Add(path);

			int num = 1;

			search: FileInfo file = new FileInfo(path + "\\" + "NewProject" + num.ToString() + ".jprj");
			if (file.Exists)
			{
				num++;
				goto search;
			}

			nameTextBox.Text = "NewProject" + num.ToString();
		}

		private void LabelTextChanged(object sender, System.EventArgs e)
		{
			if (nameTextBox.Text == "")
			{
				infoLabel.Visible = false;
				fullNameLabel.Visible = false;
			}
			else
			{
				infoLabel.Visible = true;
				fullNameLabel.Visible = true;
			}

			fullNameLabel.Text = pathComboBox.Text + "\\" + nameTextBox.Text.TrimEnd('.') + ".";

			const int w = 350;

			Graphics g = fullNameLabel.CreateGraphics();
			SizeF size = g.MeasureString(fullNameLabel.Text, fullNameLabel.Font, w);

			fullNameLabel.Width = (int)Math.Ceiling(size.Width);
			fullNameLabel.Height = (int)Math.Ceiling(size.Height);

			g.Dispose() ;
		}

		public string ResultName
		{
			get
			{
				string name = this.nameTextBox.Text;
				
				if (!name.EndsWith(".jprj"))
					name = string.Concat(name, ".jprj");
				
				return name;
			}
		}
		
		public string ResultLocation
		{
			get
			{
				string location = this.pathComboBox.Text;
				if (!location.EndsWith("/"))
					location = string.Concat(location, "/");
				return location;
			}
		}

		public bool CopyCurrentProject()
		{
			return this.copyCheckBox.Checked;
		}
		

		private void browseButton_Click(object sender, System.EventArgs e)
		{
			folderBrowserDialog.Description = "Project Location";

			if (folderBrowserDialog.ShowDialog() == DialogResult.OK)
			{
				pathComboBox.Text = folderBrowserDialog.SelectedPath ;
				pathComboBox.Items.Add(pathComboBox.Text);
			}	
		}

		private void okButton_Click(object sender, System.EventArgs e)
		{
			FtsProject newProject = null;
			string name = ResultName;
			string location = ResultLocation;
			string fileName = location + name;
			
			ProjectEditor.CloseWindowsAndSave();
			
			if (!CopyCurrentProject())
			{
				try
				{
					newProject = new FtsProject();
				}
				catch (IOException ex)
				{
					Console.Error.WriteLine("[ProjectEditor]: Error in FtsProject creation!");
					Console.Error.WriteLine(ex.StackTrace);
				}
				newProject.Save(fileName);
				newProject.FileName = fileName;
				newProject.Dir = location;
				JMaxLibrary.Project = newProject;
				newProject.SetAsCurrentProject();
			}
			else
			{
				/* save a copy of current project */
				JMaxLibrary.Project.Save(fileName);
				
				/* load the copy */
				try
				{
					JMaxLibrary.LoadProject(fileName);
				}
				catch (IOException ex)
				{
					Console.Error.WriteLine("[ProjectEditor]: I/O error loading project " + fileName);
				}
			}
		}

		private void cancelButton_Click(object sender, System.EventArgs e)
		{
			this.Close();
			this.Dispose();
		}
	}
}
